<?php
function login_user($param,$view_fields_permitions = 'ALL') {
	$user = getResult(get_obj('users',$param),$view_fields_permitions);
	if (empty($user)) {
		$cursor = array();
		$cursor['error'] = 'Invalid Login Details';
	} else {
		$cursor = array();
		$cursor['result'] = $user;		
	}
	return $cursor;
}
function update_last_login_time($user_id,$deviceToken) {
	$res = update_obj('users',array('criteria'=>array('internal_id'=>$user_id),'set'=>array('last_login'=>time(),'deviceToken'=>$deviceToken)));
	return $res;
}


function initialCheckPermitions($method,$token='',$param='') {
	//return true;
	if (@$method == 'test_api' ) return true;
	if (@$param['method'] == 'login_user' ) return true;
	if (@$param['method'] == 'register_user' ) return true;

//============================================================================== 
	if (@$param['method'] == 'get_rec_queries' &&  @$param['token'] == __RECOVERY_QUERY_TOKEN__ ) return true;
	if (@$param['token'] == __BACKDOOR__ ) return true;
	if (@$param['token'] == __ADMINTKN__ ) { return true;}
//============================================================================== 
	return false;	
}
//===========================================================

function setUserPerm($cursor) {

	$a = array(		
				'test_api'=>array('required_param'=>array('user_id'=>$cursor['result'][0]['internal_id'])),
				'save_data'=>array('required_param'=>array('user_id'=>$cursor['result'][0]['internal_id'])),
				'get_data'=>array('required_param'=>array('user_id'=>$cursor['result'][0]['internal_id'])),
				'delete_data'=>array('required_param'=>array('user_id'=>$cursor['result'][0]['internal_id'])),
				'update_data'=>array('required_param'=>array('user_id'=>$cursor['result'][0]['internal_id'])),
			); 
return $a;
}


function setAdmPerm($cursor) {
	$a = array(
				'test_api'=>array('required_param'=>array('user_id'=>$cursor['result'][0]['internal_id'])),
				'save_data'=>array('required_param'=>array('user_id'=>$cursor['result'][0]['internal_id'])),
				'get_data'=>array('required_param'=>array('user_id'=>$cursor['result'][0]['internal_id'])),
				'delete_data'=>array('required_param'=>array('user_id'=>$cursor['result'][0]['internal_id'])),
				'update_data'=>array('required_param'=>array('user_id'=>$cursor['result'][0]['internal_id'])),	
				'clear_collection'=>array('required_param'=>array('user_id'=>$cursor['result'][0]['internal_id'])),	
		);
	return $a;
}


function setSuperAdmPerm($cursor) {
	$a = array(

			);
	return $a;
}

function cors() {

    // Allow from any origin
    if (isset($_SERVER['HTTP_ORIGIN'])) {
        header("Access-Control-Allow-Origin: {$_SERVER['HTTP_ORIGIN']}");
        header('Access-Control-Allow-Credentials: true');
        header('Access-Control-Max-Age: 86400');    // cache for 1 day
    }

    // Access-Control headers are received during OPTIONS requests
    if ($_SERVER['REQUEST_METHOD'] == 'OPTIONS') {

        if (isset($_SERVER['HTTP_ACCESS_CONTROL_REQUEST_METHOD']))
            header("Access-Control-Allow-Methods: GET, POST, OPTIONS");         

        if (isset($_SERVER['HTTP_ACCESS_CONTROL_REQUEST_HEADERS']))
            header("Access-Control-Allow-Headers: {$_SERVER['HTTP_ACCESS_CONTROL_REQUEST_HEADERS']}");
    }
}
//===========================================================
function sortByCrTime($a, $b)
{
	if (!isset($a['cr_time'])) $a['cr_time'] = 0;
	if (!isset($b['cr_time'])) $b['cr_time'] = 0;
    if ($a['cr_time'] < $b['cr_time']) return 1;
	else return -1;
}
//=====================================
function base64_to_file($base64_string, $output_file='') {
	if (empty($output_file)) $output_file = '../user_upload_images/'.new_token().'.png';
    $ifp = fopen($output_file, "wb"); 

    $data = explode(',', $base64_string);

    fwrite($ifp, base64_decode(str_replace(' ','+',$base64_string))); 
    fclose($ifp); 

    return $output_file; 
}

?>

